#include <stdio.h>
#include <stdlib.h>
/*
 * Lame anim 1.0.1 by Igor2
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * The author (Igor2) can be reached at: Igor2@maffia.hu
 *
 * AmigaOS-SAS/C port: Charlie/iNQ
 */

#include <OS.h>

void anim(FILE *play_file, int counter, int for_pos) {
char line_buff[256];
char *row;
int int_param,tmp;

 while(!(feof(play_file))) {
  row=line_buff;
  fgets(row,254,play_file);  
  if (*row=='@') {//command
   row++; 
   line_buff[254]=0; //protect atoi
   int_param=atoi(row+2);
   switch (*row) {
    case 's': //sleep
	snooze(int_param);
     break;
    case 'c': //clear screen
	printf(" \033[2J");
     break;
    case 'f': //for
      tmp=ftell(play_file);
      anim(play_file,int_param,tmp);
      break;
    case 'n': //next
      counter--;
      if (counter>0) fseek(play_file,for_pos,SEEK_SET);
      else return;
      break;       
    case 'k': 
     printf("> %s",row+2);
     getc(stdin);
     break;
    case 'r': 
     rewind(play_file);
     break;
   }
  }  
  else printf("%s",row);
 }
}

void cpy() {
 printf("\n\nLame anim 1.0.1 by Igor2. GPL, read copyright\n");
 printf("BeOS port by Averon/iNQ\n");

 printf("\n");
}

int main(int argc,char *argv[]) {
 FILE *play_file;
 if (argc<2) {
  printf("Usage: Anim <filename>\n");
  cpy();
  return 1;
 }
 play_file=fopen(argv[1],"r");
 if (play_file==NULL) {
  printf("can't read file %s\n",argv[1]);
  cpy();
  return 2;
 } 
 anim(play_file,1,0);
 fclose(play_file);
 cpy();
 return 0;
}